package l_msg_api

const (
	serverHost = "http://127.0.0.1:8001"
	timeOut    = 60
)

const (
	DDSelectField   = "DDSelectField"
	DDTextField     = "TextField"
	DDTextareaField = "TextareaField"
	DDNumberField   = "NumberField"
	DDDateField     = "DDDateField"
)

type RequestPath string

const (
	accessToken RequestPath = "/oauth/v1/accesstoken"
	oaCreat     RequestPath = "/msg/v1/dingtalk/oa/create"
	oaGet       RequestPath = "/msg/v1/dingtalk/oa/get"
	oaComment   RequestPath = "/msg/v1/dingtalk/oa/comment"
	sendSms     RequestPath = "/msg/v1/sms/send"
	sendSmsHs   RequestPath = "/msg/v1/sms/send/hs"
)

type SmsBusiness string

const (
	SmsBusinessHs      SmsBusiness = "hs"
	SmsBusinessDefault SmsBusiness = "aliyun"
)

var smsBusinessWithRequestPath = map[SmsBusiness]RequestPath{
	SmsBusinessHs:      sendSmsHs,
	SmsBusinessDefault: sendSms,
}

type (
	SmsOption     func(*SmsOptionData)
	SmsOptionData struct {
		Business SmsBusiness
	}
)

func WithBusiness(business SmsBusiness) SmsOption {

	return func(OptionData *SmsOptionData) {
		OptionData.Business = business
	}
}
